# publik-django-templatetags
# Copyright (C) 2022  Entr'ouvert
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django import template

register = template.Library()


@register.filter
def objects(cards, slug):
    return getattr(cards, slug).objects


@register.filter
def with_custom_view(queryset, custom_view_id):
    return queryset.with_custom_view(custom_view_id)


@register.filter
def get_full(queryset):
    return queryset.get_full()


@register.filter
def access_control(queryset, user):
    return queryset.access_control(user)


@register.filter
def count(queryset):
    return queryset.count


@register.filter
def filter_by(queryset, attribute):
    return queryset.filter_by(attribute)


@register.filter
def filter_value(queryset, value):
    return queryset.apply_filter_value(value)


@register.filter
def filter_by_internal_id(queryset, internal_id):
    return queryset.filter_by_internal_id(internal_id)


@register.filter
def filter_by_number(queryset, number):
    return queryset.filter_by_number(number)


@register.filter
def filter_by_user(queryset, user):
    return queryset.filter_by_user(user)


@register.filter
def filter_by_status(queryset, status):
    return queryset.filter_by_status(status)


@register.filter(name='equal')
def eq(queryset):
    return queryset.apply_eq()


@register.filter(name='not_equal')
def ne(queryset):
    return queryset.apply_ne()


@register.filter(name='less_than')
def lt(queryset):
    return queryset.apply_lt()


@register.filter(name='less_than_or_equal')
def lte(queryset):
    return queryset.apply_lte()


@register.filter(name='greater_than')
def gt(queryset):
    return queryset.apply_gt()


@register.filter(name='greater_than_or_equal')
def gte(queryset):
    return queryset.apply_gte()


@register.filter
def order_by(queryset, attribute):
    return queryset.order_by(attribute)
